/*
    2009 - Copyright by Bee <http://www.honeybeenet.altervista.org>.
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/


//https://developer.mozilla.org/en/NsIPrefBranch
var beefree_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var beefree_prefs_name = "extensions.beefree.";//must be lowercase

function beefree_pref_name(name)
{
    return beefree_prefs_name + name.toLowerCase();
}

////////////////////////////////////////////////////////////////////////////////

function beefree_pref_do_exists(name)
{
    var ok = false;
    try
    {
        var t = beefree_prefs.getPrefType(beefree_pref_name(name));
        ok = 
            (t == Components.interfaces.nsIPrefBranch.PREF_BOOL) ||
            (t == Components.interfaces.nsIPrefBranch.PREF_INT) ||
            (t == Components.interfaces.nsIPrefBranch.PREF_STRING) ||
            false;
    } catch(e) { }
    return ok;
}

function beefree_pref_do_delete(name)
{
    try
    {
         beefree_prefs.clearUserPref(beefree_pref_name(name)); 
    } catch(e) { }
}

function beefree_pref_do_get_integer(name, default_value)
{
    var value = default_value;
    var error = false;
    try
    {
        value = beefree_prefs.getIntPref(beefree_pref_name(name)); 
    } catch(e) { error = true; }
    return error ? default_value : value;
}

function beefree_pref_do_get_string(name, default_value)
{
    var value = default_value;
    var error = false;
    try
    {
        value = beefree_prefs.getCharPref(beefree_pref_name(name)); 
    } catch(e) { error = true; }
    return error ? default_value : value;
}

function beefree_pref_do_get_bool(name, default_value)
{
    var value = default_value;
    var error = false;
    try
    {
        value = beefree_prefs.getBoolPref(beefree_pref_name(name)); 
    } catch(e) { error = true; }
    return error ? default_value : value;
}

function beefree_pref_do_set_integer(name, value)
{
    beefree_prefs.setIntPref(beefree_pref_name(name), value);
}

function beefree_pref_do_set_string(name, value)
{
    beefree_prefs.setCharPref(beefree_pref_name(name), value);
}

function beefree_pref_do_set_bool(name, value)
{
    beefree_prefs.setBoolPref(beefree_pref_name(name), value == true);
}


