/*
    2009 - Copyright by Bee <http://www.honeybeenet.altervista.org>.
    This program is free software; you can redistribute it and/or
    modify it ander the terms of the GNU General Public License
    as published by the Free Software Foandation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foandation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

var BEEFREE_QUERY_EXTRACT_BEGIN = 1;
var BEEFREE_QUERY_EXTRACT_END = 2;

function beefree_query_extract(address, name, command)
{
    return beefree_query_extract_ext(address, name, command, "?", "=", "&");
}

function beefree_query_extract_ext(address, name, command, str_query, str_assign, str_next)
{
    var index = address.indexOf(str_query);//str_query=?
    if(index > 0)
        index = address.indexOf(name + str_assign, index);//str_assign==
    if(index > 0)
    {
        switch(command)
        {
            case 1://BEEFREE_QUERY_EXTRACT_BEGIN
                //Find the beginning of the evil address
                index += name.length + str_assign.length;
                break;
            case 2://BEEFREE_QUERY_EXTRACT_END
                //Find the end (chars count) of the evil address
                index += name.length + str_assign.length;
                var index_end = address.indexOf(str_next, index + 0);//str_next=&
                if(index_end < 0)
                    index_end = address.length;//if there is nothing else..
                index = index_end - index;
                break;
            default:
                alert("Bad command! It's unknown!!!");
                index = -1;
                break;
        }
    }
    else
        index = -1;
    return index;
}


function beefree_query_get(address, name)
{
    return beefree_query_get_ext(address, name, "?", "=", "&");
}

function beefree_query_get_ext(address, name, str_query, str_assign, str_next)
{
    var address_new_s = -1;
    var address_new_e = -1;
    var val = "";
    address_new_s = beefree_query_extract_ext(address, name, BEEFREE_QUERY_EXTRACT_BEGIN, str_query, str_assign, str_next);
    address_new_e = beefree_query_extract_ext(address, name, BEEFREE_QUERY_EXTRACT_END, str_query, str_assign, str_next);
    if(address_new_s > 0 && address_new_e > 0)
    {
        val = address.substr(address_new_s, address_new_e);
    }
    return val;
}

function beefree_query_get_and_translate_address(address, name, multiple)
{
    return beefree_query_get_and_translate_address_ext(address, name, multiple, "?", "=", "&");
}

function beefree_query_get_and_translate_address_ext(address, name, multiple, str_query, str_assign, str_next)
{
    var address_new_s = -1;
    var address_new_e = -1;
    var address_new = "";
    address_new_s = beefree_query_extract_ext(address, name, BEEFREE_QUERY_EXTRACT_BEGIN, str_query, str_assign, str_next);
    address_new_e = beefree_query_extract_ext(address, name, BEEFREE_QUERY_EXTRACT_END, str_query, str_assign, str_next);
    if(address_new_s > 0 && address_new_e > 0)
    {
        address_new = unescape(  address.substr(address_new_s, address_new_e)  );
        if(multiple && (address_new.indexOf("http://") > 0 || address_new.indexOf("https://") > 0) )
        {
            var index = address_new.indexOf("https://") > 0 ? 
                        address_new.indexOf("https://") : address_new.indexOf("http://");
            address_new = address_new.substr(index, address_new.length - index);
        }
        if(beefree_is_protocol_web(address_new))
        {
            address = address_new;
        }
    }
    return address;
}

function beefree_query_cut_and_translate_address(address, name, multiple)
{
    var address_new_s = -1;
    var address_new_e = -1;
    var address_new = "";
    address_new_s = address.indexOf(name) >= 0 ? (address.indexOf(name) + name.length) : -1;
    address_new_e = address.length - address_new_s;
    if(address_new_s > 0 && address_new_e > 0)
    {
        address_new = unescape(  address.substr(address_new_s, address_new_e)  );
        if(multiple && (address_new.indexOf("http://") > 0 || address_new.indexOf("https://") > 0) )
        {
            var index = address_new.indexOf("https://") > 0 ? 
                        address_new.indexOf("https://") : address_new.indexOf("http://");
            address_new = address_new.substr(index, address_new.length - index);
        }
        if(beefree_is_protocol_web(address_new))
        {
            address = address_new;
        }
    }
    return address;
}

